Tests: use babeltrace2 for all tests
[lttng-tools.git] / tests / regression / tools / streaming / test_high_throughput_limits
index 32c3f1f2b939abc060b0e256bc87b37eb56d3269..cd97dc7769ce8ae19913d6f2df3cd923b8e12937 100755 (executable)
@@ -1,20 +1,9 @@
 #!/bin/bash
 #
-# Copyright (C) 2012 Christian Babeux <christian.babeux@efficios.com>
-#                      David Goulet <dgoulet@efficios.com>
+# Copyright (C) 2012 Christian Babeux <christian.babeux@efficios.com>
+# Copyright (C) 2012 David Goulet <dgoulet@efficios.com>
 #
-# This library is free software; you can redistribute it and/or modify it under
-# the terms of the GNU Lesser General Public License as published by the Free
-# Software Foundation; version 2.1 of the License.
-#
-# This library is distributed in the hope that it will be useful, but WITHOUT
-# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
-# details.
-#
-# You should have received a copy of the GNU Lesser General Public License
-# along with this library; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
+# SPDX-License-Identifier: LGPL-2.1-only
 
 TEST_DESC="Streaming - High throughput with bandwidth limits"
 
@@ -31,7 +20,7 @@ SESSIOND_CTRL_PORT=5342
 SESSIOND_DATA_PORT=5343
 DEFAULT_IF="lo"
 
-TRACE_PATH=$(mktemp -d)
+TRACE_PATH=$(mktemp --tmpdir -d tmp.test_streaming_high_throughput_limits_trace_path.XXXXXX)
 
 NUM_TESTS=104
 
@@ -41,6 +30,12 @@ if [ ! -x "$TESTAPP_BIN" ]; then
        BAIL_OUT "No UST events binary detected."
 fi
 
+function reset_bw_limit
+{
+       tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
+       return $?
+}
+
 function set_bw_limit
 {
        limit=$1
@@ -51,28 +46,47 @@ function set_bw_limit
        # parent qdisc (1:) will always limit us to the right max value
        dataportlimit=$((9*${ctrlportlimit}))
 
+       diag "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
 
        tc qdisc add dev $DEFAULT_IF root handle 1: htb default 15 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
 
        # the total bandwidth is the limit set by the user
        tc class add dev $DEFAULT_IF parent 1: classid 1:1 htb rate ${limit}kbit ceil ${limit}kbit >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
        # 1/10 of the bandwidth guaranteed and traffic prioritized for the control port
        tc class add dev $DEFAULT_IF parent 1:1 classid 1:10 htb rate ${ctrlportlimit}kbit ceil ${limit}kbit prio 1 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
        # 9/10 of the bandwidth guaranteed and can borrow up to the total bandwidth (if unused)
        tc class add dev $DEFAULT_IF parent 1:1 classid 1:11 htb rate ${dataportlimit}kbit ceil ${limit}kbit prio 2 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
 
        # filter to assign control traffic to the 1:10 class
        tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_CTRL_PORT 0xffff flowid 1:10 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
        # filter to assign data traffic to the 1:11 class
        tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_DATA_PORT 0xffff flowid 1:11 >/dev/null 2>&1
+       if [ $? -ne 0 ]; then
+               reset_bw_limit
+               return 1
+       fi
 
-       ok $? "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
-}
-
-function reset_bw_limit
-{
-       tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
-       ok $? "Reset bandwith limits"
+       return 0
 }
 
 function create_lttng_session_with_uri
@@ -91,7 +105,7 @@ function run_apps
                # due to very slow communication between the consumer and relayd making
                # the status reply from the consumer quite slow thus delaying the
                # registration done message.
-               LTTNG_UST_REGISTER_TIMEOUT=-1 $TESTAPP_BIN $NR_ITER & >/dev/null 2>&1
+               LTTNG_UST_REGISTER_TIMEOUT=-1 $TESTAPP_BIN -i $NR_ITER & >/dev/null 2>&1
        done
 }
 
@@ -112,12 +126,11 @@ function test_high_throughput
 
 function validate_event_count
 {
+       TEMP_FILE=$(mktemp --tmpdir tmp.streaming_high_throughput_limit_file1.XXXXXX)
+       TEMP_FILE_2=$(mktemp --tmpdir tmp.streaming_high_throughput_limit_file2.XXXXXX)
 
-       TEMP_FILE=$(mktemp)
-       TEMP_FILE_2=$(mktemp)
-
-       traced=$(babeltrace $TRACE_PATH 2>/dev/null | wc -l)
-       babeltrace $TRACE_PATH >/dev/null 2>$TEMP_FILE_2
+       traced=$("$BABELTRACE_BIN" $TRACE_PATH 2>/dev/null | wc -l)
+       "$BABELTRACE_BIN" $TRACE_PATH >/dev/null 2>$TEMP_FILE_2
 
        cat $TEMP_FILE_2 | cut -f4 -d " " >$TEMP_FILE
 
@@ -148,16 +161,17 @@ function validate_event_count
 function interrupt_cleanup()
 {
        diag "*** Exiting ***"
-       stop_lttng_relayd
-       stop_lttng_sessiond
        reset_bw_limit
-       exit 1
+       # invoke utils cleanup
+       full_cleanup
 }
 
 plan_tests $NUM_TESTS
 
 print_test_banner "$TEST_DESC"
 
+bail_out_if_no_babeltrace
+
 if [ "$(id -u)" == "0" ]; then
        isroot=1
 else
@@ -168,8 +182,7 @@ skip $isroot "Root access is needed to set bandwith limits. Skipping all tests."
 {
 
        # Catch sigint and try to cleanup limits
-       trap interrupt_cleanup SIGTERM
-       trap interrupt_cleanup SIGINT
+       trap interrupt_cleanup SIGTERM SIGINT
 
        BW_LIMITS=(3200 1600 800 400 200 100 50 25)
        for BW in ${BW_LIMITS[@]};
@@ -177,6 +190,7 @@ skip $isroot "Root access is needed to set bandwith limits. Skipping all tests."
                diag "Test high-throughput with bandwidth limit set to ${BW}kbits"
 
                set_bw_limit $BW
+               ok $? "Setting bandwidth limit"
 
                start_lttng_sessiond
                start_lttng_relayd "-o $TRACE_PATH"
@@ -185,5 +199,6 @@ skip $isroot "Root access is needed to set bandwith limits. Skipping all tests."
                stop_lttng_relayd
                stop_lttng_sessiond
                reset_bw_limit
+               ok $? "Reset bandwith limits"
        done
 }
This page took 0.025347 seconds and 4 git commands to generate.